% equil_for_comp_stats_Rev2
%This has set pb, pn, etc.

if comp_stats_tag==0

    if cost_ind==1 %In this case want the firm to commit to pi = 0
        pB20 = zeros(1,Nchi);
        pB0 = zeros(1,Nchi);
        aB0 = pB0;
        aB20 = pB0;
        pN0 = pB0;
        aN0 = pB0;
    else
        if cost_ind==2
            phi = 0;
            pB20 = zeros(1,Nchi);
            pB0 = zeros(1,Nchi);
            aB0 = pB0;
            aB20 = pB0;
            pN0 = pB0;
            aN0 = pB0;
        else
            if cost_ind==3
                phi = 0;
            end
        end
    end
end

%Here we need to find the equilibrium theta, given gamma
Ntheta = 20;
THETA = linspace(0.02,0.05,Ntheta);

Big_phi = zeros(1,Ntheta);
URATE = zeros(1,Ntheta);
DUR = zeros(1,Ntheta);
TUR = zeros(1,Ntheta);
FRAUD = zeros(1,Ntheta);
IPDR = zeros(1,Ntheta);
TAUL = zeros(1,Ntheta);
WEL = zeros(1,Ntheta);
for t = 1:Ntheta
    theta = THETA(t);
    diff_tau = 1;
    toler_tau = 1e-4;
    counter_tau = 1;
    while diff_tau>toler_tau
            pB = pB0;
            pN = pN0;
            pB2 = pB20;
            pN2 = pN20;
            aB = aB0;
            aB2 = aB20;
            aN = aN0;
            aN2 = aN20; %Resetting these to find value functions, etc.
            tqt = theta*q(theta,eta);
            diff = 1;
            toler = 1e-6;
            counter_v = 1;
            %Given theta, calculate chiB and chiN, which requires value function
            %iteration
            Nchi = 100; %Number of grid points
            CHI1 = linspace(1e-4,1.5,Nchi-10);
            CHI2 = linspace(2,10,10);
            CHI = [CHI1 CHI2];

            W1 = zeros(1,Nchi);
            W2 = W1;
            W3 = W1;
            S1 = W1;
            S2 = W1;
            S3 = W1;
            W_ind = W1;
            W = W1;
            En1_opt = W1;
            J1 = W1;
            N1_opt = W1;
            for i = 1:Nchi
                chi = CHI(i);
                [woptc1,s1opt] = wagechi1FC(chi,theta,b,d,r,pB(i),pN(i),aB(i),aN(i),nu_n,nu_b,phi,TAU1(i),cb,cn,c,beta,lambda,sigma,eta,tauL,y);

                W1(i) = woptc1(1);
                S1(i) = -s1opt; %Value of the surplus at optimal wage

                [woptc2,s2opt] = wagechi2FC(chi,theta,b,d,r,pB2(i),aB2(i),nu_b,phi,TAU2(i),cb,c,beta,lambda,sigma,eta,tauL,y);
                W2(i) = woptc2(1);
                S2(i) = -s2opt;

                [woptc3,s3opt] = wagechi3(theta,d,r,beta,lambda,eta,tauL,y);
                W3(i) = woptc3(1);
                S3(i) = -s3opt;

                [~,Smi] = max([s1opt s2opt s3opt]);
                W_ind(i) = Smi;
                if Smi==1
                    W(i) = woptc1;
                else
                    if Smi==2
                        W(i) = woptc2(1);
                    else
                        W(i) = woptc3(1);
                    end
                end
            end
            %Now, given these wages, have to determine what values of chi will have
            %different wages via the bargaining process
            %First have to figure out what the current cut-offs are (i.e. current
            %decisions, given these wages
            TAU1 = tau*((b*W1)/tqt);
            TAU2 = tau*((b*W2)/tqt);
            UN1 = (b*W1-d)/(r+tqt); %Given w this is the difference between collecting and non-collecting value functions

            sN = exp(-nu_n*aN);

            sB = exp(-nu_b*aB);

            UN2 = (b*W2-d)/(r+tqt); %Update the U minus N difference with the new wage

            sN2 = exp(-nu_n*aN2);

            sB2 = exp(-nu_b*aB2);

            if commit_ind==1 %Workers have committed to no fraud
                chiN_iF = 1;
                chiN_i = 1;
                chiN = 0;
                chiN0 = 0;
            else
                FC_N = (lambda*(TAU1.*(1-pN.*sN)+(c.*pN).^2))*((1-(sigma*lambda)/(r+lambda+sigma)));
                chiN_func = FC_N+CHI.*(phi+pN.*aN)-UN1.*(1-pN.*sN);
                CHIF = linspace(CHI(1),CHI(Nchi),100000); %Make a much finer grid for CHI
                chiN_funcF = pchip(CHI,chiN_func,CHIF);
                chiN_iF = find(chiN_funcF<=0,1,'last');
                chiN = CHIF(chiN_iF);
                chiN_i = find(CHI<=chiN,1,'last');
                %Then find the orginal chiN, and this will tell us what range to find new
                %wages in
                chiN_func0 = CHI.*(phi+pN.*aN)-UN1.*(1-pN.*sN);
                chiN_func0F = pchip(CHI,chiN_func0,CHIF);
                chiN_iF0 = find(chiN_func0F<=0,1,'last');
                chiN0 = CHIF(chiN_iF0);
                chiN_i0 = find(CHI<=chiN0,1,'last');
            end
            %Now for chiB
            FC_B = (lambda*(TAU2.*(1-pB2.*sB2)+(c.*pB2).^2))*(((sigma*lambda)/(r+lambda+sigma)));
            chiB_func = FC_B+CHI.*(phi+pB2.*aB2)-UN2.*(1-pB2.*sB2);
            chiB_funcF = pchip(CHI,chiB_func,CHIF);
            chiB_iF = find(chiB_funcF<=0,1,'last');
            chiB = CHIF(chiB_iF);
            chiB_i = find(CHI<=chiB,1,'last');
            chiB_func0 = CHI.*(phi+pB2.*aB2)-UN2.*(1-pB2.*sB2);
            chiB_func0F = pchip(CHI,chiB_func0,CHIF);
            chiB_iF0 = find(chiB_func0F<=0,1,'last');
            chiB0 = CHIF(chiB_iF0);
            chiB_i0 = find(CHI<=chiB0,1,'last');
            %Now have to reset the pN,pB's etc to zero where appropriate
            pN(chiN_i+1:Nchi) = 0;
            sN(chiN_i+1:Nchi) = 0; %This is necessary for an integral below
            pB(1:chiN_i) = pB(1:chiN_i);
            pB(chiN_i+1:Nchi) = pB2(chiN_i+1:Nchi);
            aB(1:chiN_i) = aB(1:chiN_i);
            aB(chiN_i+1:Nchi) = aB2(chiN_i+1:Nchi);
            sB(1:chiN_i) = sB(1:chiN_i);
            sB(chiN_i+1:Nchi) = sB2(chiN_i+1:Nchi);
            %Now we can compute some integrals that are needed to find the flows
            if sigmachi==0
                fxn = expcdf(chiN,muchi);
                fxb = expcdf(chiB,muchi);
            else
                fxn = logncdf(chiN,muchi,sigmachi); %Fraction with chi below chiN
                fxb = logncdf(chiB,muchi,sigmachi); %Fraction with chi below chiB
            end
            pp_pnsn = pchip(CHI,(1-pN.*sN).*fdist(CHI,muchi,sigmachi));
            FXN = integral(@(x)ppval(pp_pnsn,x),0,chiN);
            pp_pbsb = pchip(CHI,(1-pB.*sB).*fdist(CHI,muchi,sigmachi));
            FXB = integral(@(x)ppval(pp_pbsb,x),0,chiB);
            tq = theta*q(theta,eta);
            ne_B = nE_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
            ne_N = nN_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
            % nu_B = nuB_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
            % nu_N = nuN_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
            %Make a vector of the nuBs
            NU_B = ((lambda*fdist(CHI,muchi,sigmachi))/((sigma+lambda)*(lambda+tqt))).*(lambda*(1-pN.*sN)+sigma*(1-pB.*sB)); %Vector of unemployed collectors, for each chi
            pp_nub = pchip(CHI,NU_B);
            nu_B = integral(@(x)ppval(pp_nub,x),0,chiB);
            nu_N = 1-ne_B-ne_N-nu_B;
            pp_dn = pchip(CHI,(pN.*sN).*fdist(CHI,muchi,sigmachi)); %This is probabiltiy of being denied
            DXN = integral(@(x)ppval(pp_dn,x),0,chiN);
            pp_db = pchip(CHI,(pB.*sB).*fdist(CHI,muchi,sigmachi));
            DXB = integral(@(x)ppval(pp_db,x),0,chiB);
            ipdr = (ne_B*DXB)/(ne_B*DXB+ne_N*DXN); %This is the improper denial rate: fraction that apply * probability of successful review
            fraud = (FXN*ne_N)/nu_B;
            pp_pb = pchip(CHI,pB.*fdist(CHI,muchi,sigmachi));
            PB = integral(@(x)ppval(pp_pb,x),0,chiB);
            pp_pn = pchip(CHI,pN.*fdist(CHI,muchi,sigmachi));
            PN = integral(@(x)ppval(pp_pn,x),0,chiN);
            challenged = DXB/fxb + DXN/fxn; %Average probability of being denied...should be 70% to match data
            %Calculate the total cost to the economy of applying for UI benefits
            %For non-eligible
            pp_pncost = pchip(CHI,pN.*aN.*fdist(CHI,muchi,sigmachi));
            PN_cost = integral(@(x)ppval(pp_pncost,x),0,chiN);
            pp_pbcost = pchip(CHI,pB.*aB.*fdist(CHI,muchi,sigmachi));
            PB_cost = integral(@(x)ppval(pp_pbcost,x),0,chiB);
            %What is unemployment and take-up rates
            u_rate = nu_B+nu_N;
            duration = 1/tqt;
            tu_rate3 = ((1-u_rate)*nu_B)/(u_rate*ne_B);
            %Now we also need to calculate the market clearing gamma, given the
            %targeted theta
            %Create the piecewise wage function
            ChiG_wage = CHI(1:(Nchi/10));
            leng = length(CHI(chiB_i:(Nchi/10)));
            w3 = W3(1)*ones(1,leng-1);
            Wage = [];
            Wage = [Wage W1(1:chiN_i)];
            Wage = [Wage W2(chiN_i+1:chiB_i)];
            Wage = [Wage w3];
            Wage(1:chiN_i) = W1(1:chiN_i);
            Wage(chiN_i+1:chiB_i) = W2(chiN_i+1:chiB_i);
            Wage(chiB_i+1:(Nchi/10)) = w3;

            %Now we also need to calculate the market clearing gamma, given the
            %targeted theta
            %First for chi between 0 and chiN
            CB = -TAU1+pB.*sB.*TAU1-(c.*pB).^2; 
            CN = -TAU1+pN.*sN.*TAU1-(c.*pN).^2;
            CB2 = -TAU2+pB2.*sB2.*TAU2-(c.*pB2).^cb;
            CN2 = -TAU2+pN2.*sN2.*TAU2-(c.*pN2).^cn;
            JBmJN = (lambda*(CB-CN))/(r+lambda);
            J1 = (1/(r+lambda))*(y-W1-tauL+lambda*CN+((sigma*lambda*(CB-CN))/(r+lambda+sigma)));
            pp_J1 = pchip(CHI,J1.*fdist(CHI,muchi,sigmachi));
            intJ1 = integral(@(x)ppval(pp_J1,x),0,chiN);
            J2 = (1/(r+lambda))*(y-W2-tauL+((sigma*lambda*CB2)/(r+lambda+sigma)));
            pp_J2 = pchip(CHI,J2.*fdist(CHI,muchi,sigmachi));
            intJ2 = integral(@(x)ppval(pp_J2,x),chiN,chiB);
            J3 = ((1/(r+lambda))*(y-W3(1)-tauL)).*fdist(CHI,muchi,sigmachi);
            pp_J3 = pchip(CHI,J3);
            intJ3 = integral(@(x)ppval(pp_J3,x),chiB,CHI(Nchi));
            big_phi = gamma/(q(theta,eta)) - (intJ1+intJ2+intJ3);  %Given tqt, what gamma is necessary to satisfy the free-entry condition

        %Now we also have to determine UI expenditures, and calculate the tauL
        %necessary to balance the budget
        pp_coll1 = pchip(CHI,TAU1.*(1-pN.*sN).*fdist(CHI,muchi,sigmachi)); 
        pp_coll2 = pchip(CHI,TAU2.*(1-pB.*sB).*fdist(CHI,muchi,sigmachi));
        COLL_N = integral(@(x)ppval(pp_coll1,x),0,chiN);
        COLL_B = integral(@(x)ppval(pp_coll2,x),0,chiB);
        COLL = lambda*(ne_N*COLL_N+ne_B*COLL_B); %This should be the total collections of benefits
        %Now for current UI expenditures
        pp_expend1 = pchip(CHI,NU_B.*(b*W1));
        pp_expend2 = pchip(CHI,NU_B.*(b*W2));
        EXP1 = integral(@(x)ppval(pp_expend1,x),0,chiN);
        EXP2 = integral(@(x)ppval(pp_expend2,x),chiN,chiB);
        EXP = EXP1+EXP2;
        %Now can calculate tauL
        tauL_new = (EXP-COLL)/(1-u_rate);
        diff_tau = abs(tauL-tauL_new);
        tauL = (tauL+tauL_new)/2;
        counter_tau = counter_tau+1;
        if counter_tau>50
            diff_tau = toler_tau;
            display('There is an issue with tauL convergence')
        end
    end
    Big_phi(t) = big_phi;
    URATE(t) = u_rate;
    DUR(t) = duration;
    TUR(t) = tu_rate3;
    FRAUD(t) = fraud;
    if isnan(ipdr)==1
        ipdr = 0;
    else
        IPDR(t) = ipdr;
    end
    TAUL(t) = tauL;
    %Some average wages
    pp_avgw1 = pchip(CHI,W1.*fdist(CHI,muchi,sigmachi));
    AVG_W1 = integral(@(x)ppval(pp_avgw1,x),0,chiN)/fxn;
    pp_avgw2 = pchip(CHI,W2.*fdist(CHI,muchi,sigmachi));
    AVG_W2 = integral(@(x)ppval(pp_avgw2,x),chiN,chiB)/(fxb-fxn);
    AVG_WAGE = integral(@(x)ppval(pp_avgw1,x),0,chiN)+integral(@(x)ppval(pp_avgw2,x),chiN,chiB)+(1-fxb)*W3(1);

    %Now look at welfare
    CBW = [CB(1:chiN_i) CB2(chiN_i+1:Nchi)];
    frac_E = ne_B/(1-u_rate);
    frac_N = ne_N/(1-u_rate);
    pp_intwB = pchip(CHI,lambda.*(-pB.^cb-pB.*aB.*CHI-phi*CHI));
    INTWB = integral(@(x)ppval(pp_intwB,x),0,chiB);
    pp_intwN = pchip(CHI,(-pN.^cn-pN.*aN.*CHI-phi*CHI).*lambda);
    INTWN = integral(@(x)ppval(pp_intwN,x),0,chiN);
    Welfare = (1-u_rate)*(y)+frac_E*INTWB+frac_N*INTWN-theta*u_rate*gamma;
    
    W0 = Welfare;
    WEL(t) = W0;
end
%Now make Big_phi finer
TF = linspace(THETA(1),THETA(Ntheta),100000);
BPF = pchip(THETA,Big_phi,TF);
ti = find(BPF>=0,1,'first');
theta = TF(ti);
URF = pchip(THETA,URATE,TF);
u_rate = URF(ti);
DURF = pchip(THETA,DUR,TF);
duration = DURF(ti);
TURF = pchip(THETA,TUR,TF);
tu_rate = TURF(ti);
FRAUDF = pchip(THETA,FRAUD,TF);
fraud = FRAUDF(ti);
IPDRF = pchip(THETA,IPDR,TF);
ipdr = IPDRF(t);
TULF = pchip(THETA,TAUL,TF);
tauL = TULF(ti);
WELF = pchip(THETA,WEL,TF);
Welfare = WELF(ti);