function [woptc3,s3opt] = wagechi3(theta,d,r,beta,lambda,eta,tauL,y)

options = optimoptions('fmincon','Display','off');
x0 = 0.8; %Initial guess for the wage
[woptc3,s3opt] = fmincon(@wagefunc,x0,[],[],[],[],0,1,[],options);
    function F = wagefunc(x)
        tqt = theta*q(theta,eta);
        En_m_N3 = (x-d)./(r+lambda+tqt);
        J3 = ((1./(r+lambda))*(y-x-tauL));
        F = -(J3.^(1-beta)).*(En_m_N3.^beta);
    end
end